#!/usr/bin/env python

import os
import matplotlib
matplotlib.use('Agg') # Must be before importing matplotlib.pyplot or pylab!
import pylab as P

import numpy as N

from netCDF4 import Dataset, num2date
    
##########################################

def andauer(tmp):

    max = 0
    num = 0
    
    for i in tmp:
    
        num = num + 1
        
        if(num > max): max = num
        
        if(i == 0): num = 0       
            
    return max

def nc2rgs(dataset,parameter,season,operation,value,lang,kurz,unit,ja,je):

    file = '/webservice/dat/tmit_day_19610101-20191231.nc'

    nc = Dataset(file,'r')

    lon = N.array(nc.variables['longitude'][:]);nx = len(lon)
    lat = N.array(nc.variables['latitude'][:]);ny = len(lat)

    nc.close()
        
    jj = N.arange(int(ja),int(je)+1,1);nj = len(jj)

    if((operation=='mean')|(operation=='sum')): 
    
        os.system('cdo -setmissval,nan -selyear,%s/%s -year%s /webservice/dat/%s_day_19610101-20191231.nc /tmp/tmp.nc'%(ja,je,operation,parameter))
        
        nc = Dataset('/tmp/tmp.nc','r')
        
        dat = N.array(nc.variables[parameter][:]);dat = dat[:,0,:,:]
        
        nc.close()

        print dat.shape

    else:
    
        os.system('cdo -setmissval,nan -selyear,%s/%s /webservice/dat/%s_day_19610101-20191231.nc /tmp/tmp.nc'%(ja,je,parameter))

        nc = Dataset('/tmp/tmp.nc','r')
        
        dat = N.array(nc.variables[parameter][:])
        
        #if((parameter=='snow')|(parameter=='wmax')):
            
        #dat = dat[:,:,:]
                
        #else:
            
        dat = dat[:,0,:,:]    
                
        tim = nc.variables['time']
                        
        tim = num2date(tim[:], units=tim.units,calendar=tim.calendar)

        jx = []
        
        for it in tim:
                
            jx.append(it.year)    
                            
        jx = N.array(jx)
                                    
        nd = len(jx)
        
        dum = N.zeros((nj,ny,nx),float); dum[:,:,:] = N.nan
        
        for j in range(nj):
        
            print jj[j]
        
            for y in range(ny):
                for x in range(nx):
              
                    if(N.isnan(N.mean(dat[:,y,x]))==False):
                                        
                        ind = N.where(jx==jj[j])[0]
                        
                        tmp = dat[ind,y,x]
                        
                        sw = float(value)
                        
                        if(operation=='perc'): dum[j,y,x] = N.percentile(tmp,sw)
                        if(operation=='gt'): dum[j,y,x] = len(tmp[tmp>sw])
                        if(operation=='lt'): dum[j,y,x] = len(tmp[tmp<sw])             
                        if(operation=='gta'): in0 = N.where(tmp<=sw)[0];in1 = N.where(tmp>sw)[0]; tmp[in0] = 0; tmp[in1] = 1; dum[j,y,x] = andauer(tmp)
                        if(operation=='lta'): in0 = N.where(tmp>=sw)[0];in1 = N.where(tmp<sw)[0]; tmp[in0] = 0; tmp[in1] = 1; dum[j,y,x] = andauer(tmp)
                                            
        nc.close()
        
        dat = dum
                                                    
        print dat.shape

    #######

    raster = '../rasterize/raster_NIT_Reisegebiete_2017.nc'
    listen = './RS.csv'  
            
    nc = Dataset(raster,'r')
                                                        
    los = N.array(nc.variables['lon'][:])
    las = N.array(nc.variables['lat'][:])
    msk = N.array(nc.variables['Band1'][:])
                                                            
    nc.close()
                                                    
    print msk.shape
                                                            
    pkt = N.genfromtxt(listen,skip_header=1,usecols=(2),delimiter=';',dtype='S')
    nam = N.genfromtxt(listen,skip_header=1,usecols=(0),delimiter=';',dtype='S')
                                                                        
    ns = len(pkt)
    
    msk = msk.ravel()
    dat = N.reshape(dat,(nj,nx*ny))

    os.system('rm -r ../csv/%s'%(kurz))
    os.system('mkdir ../csv/%s'%(kurz))

    for i in range(ns):
    
        ind = N.where(msk==(i+1))[0]
        
        f = open('../csv/%s/%s.csv'%(kurz,pkt[i]),'w')
        f.write('%6s;%6s;%10s;%10s\n'%('Jahr1','Jahr2','mean','sigma'))
    
        print pkt[i]
        
        if(len(ind)==0):
        
            for j in range(nj):
            
                f.write('%6i;%6i;%10.1f:%10.1f\n'%(jj[j],jj[j],-999.9,-999.9))
                                        
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(1961,2018,-999.9,-999.9))   
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(1961,1990,-999.9,-999.9))
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(1989,2018,-999.9,-999.9))        
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(2031,2060,-999.9,-999.9))
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(2071,2100,-999.9,-999.9))
    
        else:
    
            for j in range(nj):
    
                f.write('%6i;%6i;%10.1f;%10.1f\n'%(jj[j],jj[j],N.nanmean(dat[j,ind]),-999.9))
                
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(1961,2018,N.nanmean(N.mean(dat[:,ind],0)),-999.9))
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(1961,1990,N.nanmean(N.mean(dat[0:30,ind],0)),-999.9))
            f.write('%6i;%6i;%10.1f;%10.1f\n'%(1989,2018,N.nanmean(N.mean(dat[nj-30:nj,ind],0)),-999.9))

            if((kurz=='tmitja')|(kurz=='tmax25')|(kurz=='tmax30')|(kurz=='tmax00')): 
            
                if(kurz=='tmitja'): vname = 'tmitja';sname = 'klima'
                if(kurz=='tmax25'): vname = 'sommja';sname = 'tourismus'            
                if(kurz=='tmax30'): vname = 'hetaja';sname = 'klima'
                if(kurz=='tmax00'): vname = 'eistja';sname = 'klima'
            
                nc = Dataset('/webservice/dat/ger_'+sname+'_rcp85_30_1971-2000_p50_grd.nc','r')
                ens = N.array(nc.variables[vname][:])
                nc.close();ens = N.ravel(ens)
                f.write('%6i;%6i;%10.1f;%10.1f\n'%(1971,2000,N.nanmean(ens[ind]),-999.9))
                                                
                nc = Dataset('/webservice/dat/ger_'+sname+'_rcp85_30_2031-2060_p50_grd.nc','r')
                ens = N.array(nc.variables[vname][:])
                nc.close();ens = N.ravel(ens)                                
                f.write('%6i;%6i;%10.1f;%10.1f\n'%(2031,2060,N.nanmean(ens[ind]),-999.9))
                
                nc = Dataset('/webservice/dat/ger_'+sname+'_rcp85_30_2071-2100_p50_grd.nc','r')
                ens = N.array(nc.variables[vname][:])
                nc.close();ens = N.ravel(ens)
                f.write('%6i;%6i;%10.1f;%10.1f\n'%(2071,2100,N.nanmean(ens[ind]),-999.9))
                                                    
            else:

                f.write('%6i;%6i;%10.1f;%10.1f\n'%(1971,2000,-999.9,-999.9))     
                f.write('%6i;%6i;%10.1f;%10.1f\n'%(2031,2060,-999.9,-999.9))
                f.write('%6i;%6i;%10.1f;%10.1f\n'%(2071,2100,-999.9,-999.9))
    
        f.close()
    
    return

################################################################

pro=N.genfromtxt('csv.dat',delimiter=';',comments='#',skip_header=1,dtype='S')

np = len(pro[:,0])

for ip in range(np):

    print pro[ip,:]

    dataset = pro[ip,0]
    parameter = pro[ip,1]
    season = pro[ip,2]
    operation = pro[ip,3]
    value = pro[ip,4]
    lang = pro[ip,5]
    kurz = pro[ip,6]
    unit = pro[ip,7]
    ja = pro[ip,8]
    je = pro[ip,9]
        
    nc2rgs(dataset,parameter,season,operation,value,lang,kurz,unit,ja,je)
   