import numpy as N
import pylab as P

import pylab as P
params = {'font.serif':'serif','legend.fontsize': 8,'figure.subplot.left': 0.1,'figure.subplot.right': 0.9,'figure.subplot.bottom': 0.15,'figure.subplot.top': 0.9}
P.rcParams.update(params)

P.style.use('ggplot')

rs = N.genfromtxt('RS_donau.csv',usecols=(2),delimiter=';',comments='#',dtype='S')

#print rs

para = ['tmitja','tmax30','tmax99','niedja','nied20','nied99','tmax00','snow10','dadr18']

fig = P.figure(figsize=(10,6))
#fig.suptitle('Entwicklung von Klimaindikatoren 1961-2018 in Reisegebieten entlang der deutschen Donau', fontsize=12,color='gray')

k = 0

for ip in para:
  
    k = k+1

    fig.add_subplot(3,3,k)

    for irs in rs:

        print ip,irs

        ja = N.genfromtxt('../../csv/'+ip+'/'+irs+'.csv',skip_header=1,usecols=(0),dtype='i')
        je = N.genfromtxt('../../csv/'+ip+'/'+irs+'.csv',skip_header=1,usecols=(1),dtype='i')
        dx = N.genfromtxt('../../csv/'+ip+'/'+irs+'.csv',skip_header=1,usecols=(2),dtype='f')
    
        P.plot(ja[0:58],dx[0:58],'r',lw=0.5,alpha=0.5,label=irs)
        
        P.plot([1961,1990],[dx[59],dx[59]],'k',zorder=10)
        P.plot([1989,2018],[dx[60],dx[60]],'k',zorder=10)
        
        if((ip=='tmitja')|(ip=='tmax25')|(ip=='tmax30')|(ip=='tmax00')): 
    
            P.plot([2031,2060],[dx[62],dx[62]],'k',zorder=10)
            P.plot([2071,2100],[dx[63],dx[63]],'k',zorder=10)
        
    #P.legend(loc=2,shadow=True,bbox_to_anchor=(1, 0.5))
    P.xticks([1961,1990,2018,2031,2060,2071,2100],rotation=45)
    P.xlim(1960,2100)
    P.grid(color='w')
    P.title(ip,weight='bold')
    P.ylabel(ip)

P.tight_layout()

P.savefig('donau.png',dpi=160,bbox_inches='tight')